

p=20;  %poèet vrstev
U=zeros(p,1);  %pøipravený vektor U
h_el=0.012/p; %vyska jedné vrstvy
b=zeros (1,p);  %pøipravený vektor b 
y=37999984.80;  %vodivost tyèe
u0=4*pi*10^(-7); %permeabilita
f=linspace(50,0,10009); %linspace(0,50,50);%vektor frekvencí 
a=size(f);%velikost vektoru f 
t=a(1,2); %poèet testovacích frekvencí
kr1= zeros (1,t); %pøipravený vektor kr
kx1= zeros (1,t); %pøipravený vektor kx
r= zeros (1,p); %pøipravený vektor r
x= zeros (1,p); %pøipravený vektor x
matice=rand(p,p)+i*rand(p,p);  %pøipravený vektor dle disertace 2.34
ri_Ii=zeros (1,p); %pøipravený vektor dle disertace 2.36
Le_I=zeros (1,p);% dle disertace 2.37
Le_Ge=zeros (1,p);% dle disertace 2.37
Ge=zeros (1,p);% dle disertace 2.37

for z = 1:p  % naplnìní vektoru U
    U(z,1)=200;
end

zz=0;
for z = 1:p % naplnìní vektoru b
    h1=zz+(h_el/2);
    y1=2*(((-0.0833)*h1)+0.003);
    b(1,z)=y1;
    zz=zz+h_el;
end
lambda = h_el./b;
lambda(1) = lambda(1) + 0.001;  
d=1;
while d<=t
    z=1;
    while z<=p
        r1=1/(y*b(1,z)*h_el);
        x1=(2*pi*f(1,d)*u0)*(lambda(z));
        r(1,z)=r1;
        x(1,z)=x1;
        z=z+1;
    end
    z=1; %
    zz=2;%
    while z<=p % matice 2.34
        x1_c=complex(0,(sum(x(1,1:z))));
        matice(z,z)=r(1,z)+x1_c; %pozice na diagonále
        matice(z,zz:p)=x1_c;  %pozice na z øádku zz sloupci
        matice(zz:p,z)=x1_c;
        z=z+1; %
        zz=zz+1;%      
    end
    I_c=matice\U; %vektor proudu
    Ityc = abs(sum(I_c));
    I=(abs(I_c));
    z=1;
%     zz=p;
    while z<=p %pomocné výpoèty k 2.36 a 2.37
    ri_Ii(1,z)=((r(z))*((I(z))^2));
    Le_I(1,z)=(lambda(z))*abs(sum(I_c(z:end)))^2;
    Le_Ge(1,z)=(lambda(z))*(sum(1./r(z:end)))^2;
    Ge(1,z)=(y*b(1,z)*h_el);
    z=z+1;
%     zz=zz-1;
    end
kr(1,d)=sum(ri_Ii)/(1/(sum(1./r))*(Ityc^2));
kx(1,d)= (sum(Le_I)/((Ityc^2)))/(sum(Le_Ge)/(sum(Ge)^2));
d=d+1;
end
fh=25
krr=1.0256
kxx=0.9927
lam=(sum(Le_Ge)/(sum(Ge)^2));
figure(1);
subplot(2,1,1); plot(f,kr,'k',fh,krr,'x','MarkerSize',8), title('kr')
xlabel('frekvence [Hz]'); ylabel('kr'); legend('kr');
subplot(2,1,2); plot(f,kx,'k',fh,kxx,'x','MarkerSize',8), title('kx')
xlabel('frekvence [Hz]'); ylabel('kx'); legend('kx');


